## lomiri-download-manager 0.1.0

=== CMakeLists.txt ===
project(lomiri-download-manager)
cmake_minimum_required(VERSION 2.8)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC -pthread")

# for dh_translations to extract the domain
# (regarding syntax consistency, see http://pad.lv/1181187)
set (GETTEXT_PACKAGE "lomiri-download-manager")
add_definitions(-DI18N_DOMAIN="${GETTEXT_PACKAGE}")

# Standard install paths
include(GNUInstallDirs)

find_package(CoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -coverage" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -coverage" )
  ENABLE_COVERAGE_REPORT(TARGETS ${DIALER_APP})
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

set(QT_INSTALL_QML "${CMAKE_INSTALL_LIBDIR}/qt5/qml")

set(LDM_VERSION_MAJOR 0)
set(LDM_VERSION_MINOR 1)
set(LDM_VERSION_PATCH 0)

file(GLOB_RECURSE I18N_CPP_SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     src/**.cpp)
list(SORT I18N_CPP_SRC_FILES)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
find_package(Boost COMPONENTS log program_options REQUIRED)

find_package(PkgConfig REQUIRED)
pkg_check_modules(DBUS REQUIRED dbus-1)
pkg_check_modules(GLOG REQUIRED libglog)
pkg_check_modules(NIH_DBUS REQUIRED libnih-dbus)
pkg_check_modules(GLOG REQUIRED libglog)
pkg_check_modules(GLOG libglog)

enable_testing()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pipe -std=c++11 -Werror -O2 -Wall -W -D_REENTRANT -fPIC -pedantic -Wextra")
add_definitions("-DNDEBUG")

if(NOT CMAKE_BUILD_TYPE)
	message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
	set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if(cmake_build_type_lower MATCHES relwithdebinfo) # workaround for http://pub    lic.kitware.com/Bug/view.php?id=14696
	add_definitions(-DQT_NO_DEBUG)
endif()

add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(docs)
add_subdirectory(po)

=== docs/qml/CMakeLists.txt ===
# add a target to generate API documentation with qdoc
FIND_PROGRAM(QDOC_EXECUTABLE qdoc)
if(QDOC_EXECUTABLE)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lomiri-download-manager.qdocconf.in ${CMAKE_CURRENT_BINARY_DIR}/lomiri-download-manager.qdocconf @ONLY)
add_custom_target(qmldoc
${QDOC_EXECUTABLE} -qt=qt5 ${CMAKE_CURRENT_BINARY_DIR}/lomiri-download-manager.qdocconf
WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
COMMENT "Generating QML API documentation with qdoc" VERBATIM
)

# copy stylesheet files into build directory for shadow builds
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/css"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
    )

install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
  DESTINATION ${CMAKE_INSTALL_DOCDIR}/qml/html
)

add_dependencies(doc qmldoc)

endif(QDOC_EXECUTABLE)

=== src/common/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Manuel de la Peña <manuel.delapena@canonical.com>

add_subdirectory(priv)
add_subdirectory(public)

=== src/downloads/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Manuel de la Peña <manuel.delapena@canonical.com>

add_subdirectory(client)
add_subdirectory(common)
add_subdirectory(daemon)
add_subdirectory(priv)
add_subdirectory(qml)
add_subdirectory(test-daemon)

=== src/extractor/CMakeLists.txt ===
set(TARGET ldm-extractor)

set(SOURCES
    lomiri/downloads/extractor/deflator.cpp
    lomiri/downloads/extractor/factory.cpp
    lomiri/downloads/extractor/main.cpp
    lomiri/downloads/extractor/unzip.cpp
)

set(HEADERS
    lomiri/downloads/extractor/deflator.h
    lomiri/downloads/extractor/factory.h
    lomiri/downloads/extractor/unzip.h
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)

add_executable(${TARGET}
	${HEADERS}
	${SOURCES}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
        ${Qt5Core_LIBRARIES}
        ${Boost_LIBRARIES}
	ldm-priv-common
)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/lomiri-download-manager)

=== tests/abi-compliance/CMakeLists.txt ===
configure_file(abi.xml.in ${CMAKE_CURRENT_BINARY_DIR}/abi.xml)

=== tests/common/CMakeLists.txt ===
set(TARGET lomiri-download-manager-test-lib)

set(SOURCES
        base_testcase.cpp
        daemon_testcase.cpp
        local_tree_testcase.cpp
        testing_interface.cpp
)

set(HEADERS
        apparmor.h
        base_testcase.h
        daemon_testcase.h
        dbus_connection.h
        file_manager.h
        local_tree_testcase.h
        matchers.h
        network_reply.h
        process.h
        process_factory.h
        request_factory.h
        testing_interface.h
        uuid_factory.h
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Test_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(${GMOCK_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/client)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)

link_directories(${NIH_DBUS_LIBDIR})
link_directories(${GLOG_DBUS_LIBDIR})

add_library(${TARGET} STATIC
    ${HEADERS}
    ${SOURCES}
)

target_link_libraries(${TARGET}
    ${NIH_DBUS_LIBRARIES}
    ${GLOG_LIBRARIES}
    ${Qt5Core_LIBRARIES}
    ${Qt5Sql_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ${GMOCK_LIBRARIES}
    ${GTEST_BOTH_LIBRARIES}
    ldm-common
    ldm-priv-common
    lomiri-download-manager-common
    lomiri-download-manager-client
)

=== src/common/priv/CMakeLists.txt ===
set(TARGET ldm-priv-common)

set(SOURCES
	lomiri/transfers/base_daemon.cpp
	lomiri/transfers/base_manager.cpp
	lomiri/transfers/i18n.cpp
	lomiri/transfers/queue.cpp
	lomiri/transfers/transfer.cpp
	lomiri/transfers/system/apn_proxy.cpp
	lomiri/transfers/system/apn_request_factory.cpp
	lomiri/transfers/system/apparmor.cpp
	lomiri/transfers/system/application.cpp
	lomiri/transfers/system/cryptographic_hash.cpp
	lomiri/transfers/system/dbus_proxy.cpp
	lomiri/transfers/system/dbus_proxy_factory.cpp
	lomiri/transfers/system/file_manager.cpp
	lomiri/transfers/system/filename_mutex.cpp
	lomiri/transfers/system/network_reply.cpp
	lomiri/transfers/system/network_session.cpp
	lomiri/transfers/system/nm_interface.cpp
	lomiri/transfers/system/process.cpp
	lomiri/transfers/system/process_factory.cpp
	lomiri/transfers/system/request_factory.cpp
	lomiri/transfers/system/timer.cpp
	lomiri/transfers/system/uuid_factory.cpp
	lomiri/transfers/system/uuid_utils.cpp
)

set(HEADERS
	lomiri/transfers/adaptor_factory.h
	lomiri/transfers/base_daemon.h
	lomiri/transfers/base_manager.h
	lomiri/transfers/i18n.h
	lomiri/transfers/manager_factory.h
	lomiri/transfers/queue.h
	lomiri/transfers/transfer.h
	lomiri/transfers/system/apn_proxy.h
	lomiri/transfers/system/apn_request_factory.h
	lomiri/transfers/system/apparmor.h
	lomiri/transfers/system/application.h
	lomiri/transfers/system/cryptographic_hash.h
	lomiri/transfers/system/dbus_proxy.h
	lomiri/transfers/system/dbus_proxy_factory.h
	lomiri/transfers/system/file_manager.h
	lomiri/transfers/system/filename_mutex.h
	lomiri/transfers/system/network_reply.h
	lomiri/transfers/system/network_session.h
	lomiri/transfers/system/nm_interface.h
	lomiri/transfers/system/pending_reply.h
	lomiri/transfers/system/process.h
	lomiri/transfers/system/process_factory.h
	lomiri/transfers/system/request_factory.h
	lomiri/transfers/system/timer.h
	lomiri/transfers/system/uuid_factory.h
	lomiri/transfers/system/uuid_utils.h
)

include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)

add_library(${TARGET} SHARED
	${HEADERS}
	${SOURCES}
)

set_target_properties(
	${TARGET}

	PROPERTIES
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

link_directories(${NIH_DBUS_LIBDIR})
link_directories(${GLOG_DBUS_LIBDIR})

target_link_libraries(${TARGET}
	${NIH_DBUS_LIBRARIES}
	${GLOG_LIBRARIES}
	${Qt5Network_LIBRARIES}
	${Qt5Sql_LIBRARIES}
	${Qt5Core_LIBRARIES}
	${Qt5DBus_LIBRARIES}
	ldm-common
)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/common/public/CMakeLists.txt ===
pkg_check_modules(GLOG libglog)

set(TARGET ldm-common)

set(SOURCES
	lomiri/transfers/metadata.cpp
	lomiri/transfers/errors/auth_error_struct.cpp
	lomiri/transfers/errors/hash_error_struct.cpp
	lomiri/transfers/errors/http_error_struct.cpp
	lomiri/transfers/errors/network_error_struct.cpp
	lomiri/transfers/errors/process_error_struct.cpp
	lomiri/transfers/system/dbus_connection.cpp
	lomiri/transfers/system/hash_algorithm.cpp
	lomiri/transfers/system/logger.cpp
)

set(TRANSFERS_PUBLIC_HEADERS
	lomiri/transfers/metadata.h
	lomiri/transfers/visibility.h
)

set(ERRORS_PUBLIC_HEADERS
	lomiri/transfers/errors/auth_error_struct.h
	lomiri/transfers/errors/hash_error_struct.h
	lomiri/transfers/errors/http_error_struct.h
	lomiri/transfers/errors/network_error_struct.h
	lomiri/transfers/errors/process_error_struct.h
)

set(PRIVATE_HEADERS
	lomiri/transfers/system/dbus_connection.h
	lomiri/transfers/system/hash_algorithm.h
	lomiri/transfers/system/logger.h
)

include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})

add_library(${TARGET} SHARED
	${SOURCES}
	${TRANSFERS_PUBLIC_HEADERS}
	${ERRORS_PUBLIC_HEADERS}
	${PRIVATE_HEADERS}
)

set(symbol_map "${CMAKE_SOURCE_DIR}/src/common/public/symbols.map")
set_target_properties(
	${TARGET}

	PROPERTIES
        LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	${Qt5DBus_LIBRARIES}
	${Qt5Network_LIBRARIES}
	glog
)

configure_file(${TARGET}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/pkgconfig)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${TRANSFERS_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/transfers)
install(FILES ${ERRORS_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/transfers/errors)

=== src/downloads/client/CMakeLists.txt ===
add_definitions(-DBOOST_LOG_DYN_LINK)

set(TARGET lomiri-download-manager-client)

set(SOURCES
        lomiri/download_manager/download_impl.cpp
        lomiri/download_manager/download_interface.cpp
        lomiri/download_manager/downloads_list_impl.cpp
        lomiri/download_manager/download_pendingcall_watcher.cpp
        lomiri/download_manager/error.cpp
        lomiri/download_manager/group_download.cpp
        lomiri/download_manager/logging/logger.cpp
        lomiri/download_manager/manager.cpp
        lomiri/download_manager/manager_impl.cpp
        lomiri/download_manager/manager_interface.cpp
        lomiri/download_manager/manager_pendingcall_watcher.cpp
        lomiri/download_manager/pending_call_watcher.cpp
        lomiri/download_manager/properties_interface.cpp
)

set(PUBLIC_HEADERS
        lomiri/download_manager/download.h
        lomiri/download_manager/downloads_list.h
        lomiri/download_manager/error.h
        lomiri/download_manager/group_download.h
        lomiri/download_manager/manager.h
        lomiri/download_manager/logging/logger.h
)

set(PRIVATE_HEADERS
        lomiri/download_manager/download_impl.h
        lomiri/download_manager/download_interface.h
        lomiri/download_manager/downloads_list_impl.h
        lomiri/download_manager/download_pendingcall_watcher.h
        lomiri/download_manager/manager_impl.h
        lomiri/download_manager/manager_interface.h
        lomiri/download_manager/manager_pendingcall_watcher.h
        lomiri/download_manager/pending_call_watcher.h
        lomiri/download_manager/properties_interface.cpp
)

include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${Boost_INCLUDE_DIRS})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)

add_library(${TARGET} SHARED 
        ${SOURCES}
        ${PUBLIC_HEADERS}
        ${PRIVATE_HEADERS}
)

set(symbol_map "${CMAKE_SOURCE_DIR}/src/downloads/client/symbols.map")
set_target_properties(
        ${TARGET}

        PROPERTIES
        LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
        VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
        SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
        ${Boost_LIBRARIES}
        ${Qt5DBus_LIBRARIES}
        ldm-common
        lomiri-download-manager-common
)

configure_file(${TARGET}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/pkgconfig)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/download_manager)

=== src/downloads/common/CMakeLists.txt ===
set(TARGET lomiri-download-manager-common)

set(SOURCES
	lomiri/download_manager/download_state_struct.cpp
	lomiri/download_manager/download_struct.cpp
	lomiri/download_manager/group_download_struct.cpp
	lomiri/download_manager/system/logger.cpp
)

set(PUBLIC_HEADERS
	lomiri/download_manager/download_state_struct.h
	lomiri/download_manager/download_struct.h
	lomiri/download_manager/group_download_struct.h
	lomiri/download_manager/metatypes.h
)

set(PRIVATE_HEADERS
	lomiri/download_manager/system/logger.h
)

include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)

add_library(${TARGET} SHARED 
	${SOURCES}
	${PUBLIC_HEADERS}
	${PRIVATE_HEADERS}
)


set(symbol_map "${CMAKE_SOURCE_DIR}/src/downloads/common/symbols.map")
set_target_properties(
	${TARGET}

	PROPERTIES
        LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
	VERSION ${LDM_VERSION_MAJOR}.${LDM_VERSION_MINOR}.${LDM_VERSION_PATCH}
	SOVERSION ${LDM_VERSION_MAJOR}
)

target_link_libraries(${TARGET}
	${Qt5DBus_LIBRARIES}
	ldm-common
)

configure_file(${TARGET}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.pc DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/pkgconfig)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lomiri/download_manager)

=== src/downloads/daemon/CMakeLists.txt ===
set(TARGET lomiri-download-manager)

set(SOURCES
	main.cpp
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src/common/public)
include_directories(${CMAKE_SOURCE_DIR}/src/common/priv)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/common)
include_directories(${CMAKE_SOURCE_DIR}/src/downloads/priv)

link_directories(${NIH_DBUS_LIBDIR})
link_directories(${GLOG_DBUS_LIBDIR})

add_executable(${TARGET}
	${SOURCES}
)

target_link_libraries(${TARGET}
	${GLOG_LIBRARIES}
        ${Qt5Core_LIBRARIES}
	ldm-common
	ldm-priv-common
	lomiri-download-manager-common
	lomiri-download-manager-priv
)

set (SYSTEMD_USER_DIR "/usr/lib/systemd/user")
install(
  FILES lomiri-download-manager-systemd.service
  DESTINATION ${SYSTEMD_USER_DIR}
)

install(FILES ${TARGET}.service DESTINATION
   	${CMAKE_INSTALL_DATADIR}/dbus-1/services)
install(FILES "com.canonical.applications.Downloader.service" DESTINATION
   	/usr/share/dbus-1/system-services)
install(FILES "com.canonical.applications.Downloader.conf" DESTINATION
   	/etc/dbus-1/system.d)
install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
lomiri-download-manager (0.1.0-9) unstable; urgency=medium

  [ Marius Gripsgard ]
  * debian/rules:
    + Comment out DPKG_GENSYMBOLS_CHECK_LEVEL, lets use default.
      (Closes: #995281).

  [ Mike Gabriel ]
  * debian/control:
    + Bump Standards-Version: to 4.6.0. No changes needed.
  * debian/patches:
    + Add README file explaining our patch naming scheme.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 15 Nov 2021 12:54:31 +0100

lomiri-download-manager (0.1.0-8) unstable; urgency=medium

  * debian/control:
    + Fix D (liblomiri-upload-manager-common-dev):
      liblomiri-upload-manager-common0 instead of
      liblomiri-download-manager-common0. Thanks piuparts.
      (Closes: #988808).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 23 May 2021 22:01:37 +0200

lomiri-download-manager (0.1.0-7) unstable; urgency=medium

  * debian/changelog:
    + Remove 0.1.0-5 release from changelog, never uploaded, simply skipped by
      mistake.
  * debian/control:
    + Make B-D on libgtest-dev versioned (>= 1.10.0.20201025-1~).
    + Update versioned B-D on cmake-extras (>= 1.5-7~).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 13 Dec 2020 20:45:29 +0100

lomiri-download-manager (0.1.0-6) unstable; urgency=medium

  * debian/control:
    + Add B-D: pkg-config, required by 'find_package(GMock)' in cmake-extras.
  * debian/patches:
    + Add 20021_build-without-Werror.patch. Remove -Werror from the equation
      to avoid FTBFS due to 3rd-party library updates in Debian.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 30 Oct 2020 14:41:07 +0100

lomiri-download-manager (0.1.0-4) unstable; urgency=medium

  * debian/control:
    + Update B-D for cmake-extra and require at least version 1.5-5~. (Closes:
      #973078).
    + Switch from transitional google-mock to googletest in B-D.
    + Add libgtest-dev as suggested by recent cmake-extras package.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 30 Oct 2020 09:34:35 +0100

lomiri-download-manager (0.1.0-3) unstable; urgency=medium

  * debian/control:
    + Fix Vcs-*: URLs.
  * debian/*.symbols:
    + Update symbols using pkgkde-symbolshelper.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 08 Sep 2020 15:47:40 +0200

lomiri-download-manager (0.1.0-2) unstable; urgency=medium

  * debian/control:
    + Add B-D: graphviz.
  * debian/liblomiri-download-manager-*.symbols:
    + Update symbols for arch:powerpc.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 07 Sep 2020 21:12:40 +0200

lomiri-download-manager (0.1.0-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #952726).

  * debian/watch:
    + Add file.
  * debian/control:
    + Set Maintainer: to Debian UBports Team and add myself to Uploaders:
      field. Update Homepage: field.
    + Update Vcs-*: fields.
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Add Rules-Requires-Root: field and set it to 'no'.
    + Add B-Ds: rdfind and symlinks.
    + Add B-D: pkg-kde-tools.
    + Drop from B-D: dh-translations.
    + Drop from B-D: qtdeclarative5-test-plugin; add instead: qml-module-qttest.
    + Drop some redundant 'Section: net' fields.
    + Work through SYNOPSES and LONG_DESCRIPTIONs.
  * debian/{control,*.install}:
    + Switch back to SOVERSION=0 for all shared lib bin:pkgs.
  * debian/{control,compat}:
    + Switch to debhelper-compat notation. Bump DH compat level to version 12.
  * debian/{control,*}:
    + Rename bin:pkg qtdeclarative5-lomiri-download-manager0.1 to
      qml-module-lomiri-downloadmanager.
    + Add bin:pkg qml-module-lomiri-downloadmanager-doc. Move QML API
      documentation into this bin:pkg.
  * debian/rules:
    + Move --fail-missing to dh_missing override.
    + Semantically fix dh_auto_install override.
    + Verbose file removals.
    + Use upstream's NEWS file as upstream ChangeLog.
    + Move LDM client API docs to correct folder, deduplicate files.
    + Add option --with pkgkde_symbolshelper to debhelper calls.
    + Drop now default --parallel DH option.
    + Drop --with-translations DH option. Ubuntu'ism.
    + Forcefully enable all hardening options.
    + Include architecture.mk, stop using dpkg-architecture.
    + Set QT_SELECT to 5.
    + Add get-orig-source target.
    + Fix override_dh_auto_install target. (Remove files after dh_auto_install,
      not before).
    + Remove empty directory in QML API documentation.
  * debian/copyright:
    + Update (fix) global header.
    + Add auto-generated copyright.in file.
    + Detailed file list copyright style.
    + Fine-tune, fix some syntaxt flaws.
  * debian/source/format:
    + Add file (3.0 (quilt)).
  * debian/source/lintian-overrides:
    + Override odd-historical-debian-changelog-version.
  * debian/liblomiri-download-manager-client-dev.install:
    + Install include file lomiri/download_manager/logger.h into
      liblomiri-download-manager-client-dev bin:pkg.
  * debian/liblomiri-download-manager-client-doc.doc-base:
    + Add file.
  * debian/upstream/metadata:
    + Add file. Comply with DEP-12.
  * debian/patches:
    + Add 1001_typo-fixes.patch. Fix typo in DBus specification.
    + Add 1002_doxygen-relative-paths.patch. Avoid build path in generated API
      documentation.
  * debian/*.symbols:
    + Add files (amd64 arch only, for now).
    + Add *Build-Depends-Package: fields.
  * debian/libldm-priv-common0.lintian-overrides:
    + Add file. Override warning about non-provided symbols file (private
      library).
  * man pages:
    + Add very minimal and rudimentry man pages for
      lomiri-{download,upload}-manager.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 02 Mar 2020 22:27:23 +0100

ubuntu-download-manager (1.4+ubports) xenial; urgency=medium

  * Imported to UBports

 -- UBports auto importer <infra@ubports.com>  Wed, 27 Dec 2017 03:58:30 +0100

ubuntu-download-manager (1.3+17.04.20161202-0ubuntu1) zesty; urgency=medium

  * Fix data path for unconfined downloads (LP: #1646758)



=== debian/control ===
Source: lomiri-download-manager
Section: net
Priority: optional
Build-Depends: cmake,
               cmake-extras (>= 1.5-7~),
               debhelper-compat (= 12),
               dh-apparmor,
               doxygen,
               dbus-test-runner,
               googletest,
               graphviz,
               qtbase5-dev,
               libboost-log-dev,
               libboost-program-options-dev,
               libdbus-1-dev,
               libqt5sql5-sqlite,
               libnih-dbus-dev,
               libgoogle-glog-dev,
               libgtest-dev (>= 1.10.0.20201025-1~),
               pkg-config,
               python3,
               qml-module-qttest,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qttools5-dev-tools,
               network-manager,
               rdfind,
               symlinks,
               pkg-kde-tools,
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/core/lomiri-download-manager/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-download-manager.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-download-manager/

Package: libldm-common0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Upload/Download Manager - shared library
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes the common shared library, shared between the
 client lib and the service lib.

Package: libldm-common-dev
Section: libdevel
Architecture: any
Depends: libldm-common0 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Lomiri Upload/Download Manager - development files
 Lomiri Uploadi/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the common headers, shared between the client
 library and the daemon library.

Package: libldm-priv-common0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
Description: Lomiri Upload/Download Manager - shared private library
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes an auxiliary shared (but private) library.

Package: liblomiri-download-manager-common0
Section: libs
Architecture: any
Depends: libldm-common0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QT library for Lomiri Download Manager - common shared library
 Lomiri Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package includes the common shared library between the client lib
 and the service lib.

Package: liblomiri-download-manager-common-dev
Section: libdevel
Architecture: any
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-download-manager-common0 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: QT library for Lomiri Download Manager - common development files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the common headers shared between the client
 library and the daemon library.

Package: liblomiri-download-manager-client0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
         liblomiri-download-manager-common0 (= ${binary:Version}),
Description: QT library for Lomiri Download Manager - shared client library
 Lomiri Download Manager performs downloads from a centralized location.
 .
 This package includes the public shared library providing the API
 for implementing a service client.

Package: liblomiri-download-manager-client-dev
Section: libdevel
Architecture: any
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-download-manager-common-dev (= ${binary:Version}),
         liblomiri-download-manager-client0 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: lomiri-download-manager-client-dev
Replaces: lomiri-download-manager-client-dev
Description: QT library for Lomiri Download Manager - client development files
 Lomiri Download Manager performs downloads from a centralized location.
 .
 This package contains the header that can be used to allow an
 application use the Lomiri Download Manager client library.

Package: liblomiri-download-manager-client-doc
Section: doc
Architecture: all
Depends: liblomiri-download-manager-client-dev (>= ${source:Version}),
          ${misc:Depends},
Description: QT library for Lomiri Download Manager - client documentation files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 Documentation files for the LDM client development.

Package: liblomiri-upload-manager-common0
Section: libs
Architecture: any
Depends: libldm-common0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QT library for Lomiri Upload Manager - shared common library
 Lomiri Upload Manager performs uploads from a centralized location.
 .
 This package includes the common shared library between the client lib
 and the service lib.

Package: liblomiri-upload-manager-common-dev
Section: libdevel
Architecture: any
Depends: libldm-common-dev (= ${binary:Version}),
         liblomiri-upload-manager-common0 (= ${binary:Version}),
         qtbase5-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: QT library for Lomiri Upload Manager - common development files
 Lomiri Upload Manager performs uploads from a centralized location.
 .
 This package contains the common headers shared between the client
 library and the daemon library.

Package: lomiri-download-manager
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
         libldm-priv-common0 (= ${binary:Version}),
         liblomiri-download-manager-common0 (= ${binary:Version}),
         unzip
Suggests: apparmor
Description: Lomiri Download Manager - daemon
 Lomiri Download Manager performs downloads from a centralized
 location.
 .
 This package includes the Lomiri Download Manager user space daemon.

Package: lomiri-upload-manager
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
         libldm-priv-common0 (= ${binary:Version}),
         liblomiri-upload-manager-common0 (= ${binary:Version}),
Description: Lomiri Upload Manager - daemon
 Lomiri Upload Manager performs uploads from a centralized
 location.
 .
 This package includes the Lomiri Upload Manager user space daemon.

Package: qml-module-lomiri-downloadmanager
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libldm-common0 (= ${binary:Version}),
         liblomiri-download-manager-common0 (= ${binary:Version}),
         liblomiri-download-manager-client0 (= ${binary:Version}),
         lomiri-download-manager (= ${binary:Version})
Description: Lomiri Download Manager QML Plugin
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains a QML Plugin to handle downloads from a pure QML
 application, without the need to write any C++ code.

Package: qml-module-lomiri-downloadmanager-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: Lomiri Download Manager QML Plugin - documentation files
 Lomiri Upload/Download Manager performs uploads and downloads from a
 centralized location.
 .
 This package contains the documentation of the Lomiri DownloadManager
 QML Plugin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/architecture.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT := 5

BUILDHOME=$(CURDIR)/debian/build

override_dh_clean:
	dh_clean
	rm -rfv $(BUILDHOME)

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_test:
	mkdir -p $(BUILDHOME)
	HOME=$(BUILDHOME) dh_auto_test

override_dh_auto_install:
	dh_auto_install
	rm -v debian/tmp/usr/lib/*/libldm-priv-common.so

override_dh_install:
	# liblomiri-download-manager-client-doc
	mkdir -p "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/"
	mv $(CURDIR)/debian/tmp/usr/share/doc/lomiri-download-manager/cpp/* $(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/
	find "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/" -name *.md5 -delete
	rdfind -makesymlinks true "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/"
	symlinks -rc "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-download-manager-client-doc/"
	# qml-module-lomiri-downloadmanager
	mkdir -p "$(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/"
	mv $(CURDIR)/debian/tmp/usr/share/doc/lomiri-download-manager/qml/* $(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/
	find "$(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/" -name *.md5 -delete
	rdfind -makesymlinks true "$(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/"
	symlinks -rc "$(CURDIR)/debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/"
	# this directory is empty...
	rmdir debian/tmp/usr/share/doc/qml-module-lomiri-downloadmanager-doc/html/images/
	dh_install

override_dh_missing:
	dh_missing --fail-missing

%:
	dh  $@ --with pkgkde_symbolshelper

override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.lomiri-download-manager.ldm-extractor -plomiri-download-manager
	dh_installdeb

override_dh_installchangelogs:
	dh_installchangelogs NEWS

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://gitlab.com/ubports/core/lomiri-download-manager/tags .*/lomiri-download-manager-(\d\S+)\.tar\.gz
